--[[
	### ItemValue ###
	ItemValue Jewel Data
	
--]]

local L = returnkey -- AceLibrary("AceLocale-2.2"):new("ItemValue")

ItemValue.EmptySocket = {EnchantId = 0, ItemId = 0, Name = L["Empty"], Quality = 0}

local Jewels = {
	--{2686, 23233, "Red Bryanite of Strength stuff", 2, false, false, false, false, false},
	--{2687, 23234, "Blue Bryanite of Agility", 2, false, false, false, false, false},
	--{2688, 23235, "Yellow Bryanite of Stamina", 2, false, false, false, false, false},
	{2690, 23094, "Teardrop Blood Garnet", 2, false, true, false, false, false},
	{2691, 23095, "Bold Blood Garnet", 2, false, true, false, false, false},
	{2692, 23096, "Runed Blood Garnet", 2, false, true, false, false, false},
	{2693, 23097, "Delicate Blood Garnet", 2, false, true, false, false, false},
	{2694, 23113, "Brilliant Golden Draenite", 2, false, false, true, false, false},
	{2695, 23114, "Gleaming Golden Draenite", 2, false, false, true, false, false},
	{2696, 23115, "Thick Golden Draenite", 2, false, false, true, false, false},
	{2697, 23116, "Rigid Golden Draenite", 2, false, false, true, false, false},
	{2698, 23118, "Solid Azure Moonstone", 2, false, false, false, true, false},
	{2699, 23119, "Sparkling Azure Moonstone", 2, false, false, false, true, false},
	{2700, 23120, "Stormy Azure Moonstone", 2, false, false, false, true, false},
	{2701, 23121, "Lustrous Azure Moonstone", 2, false, false, false, true, false},
	--{2703, 23364, "zzDEPRECATEDHeart of the Sky", 3, false, false, false, false, false},
	--{2704, 23366, "zzDEPRECATEDPerfect Diamond", 3, false, false, false, true, false},
	{2705, 23099, "Luminous Flame Spessarite", 2, false, true, true, false, false},
	{2706, 23105, "Enduring Deep Peridot", 2, false, false, true, true, false},
	{2707, 23106, "Dazzling Deep Peridot", 2, false, false, true, true, false},
	{2708, 23108, "Glowing Shadow Draenite", 2, false, true, false, true, false},
	{2709, 23109, "Royal Shadow Draenite", 2, false, true, false, true, false},
	{2710, 23110, "Shifting Shadow Draenite", 2, false, true, false, true, false},
	{2711, 23111, "Sovereign Shadow Draenite", 2, false, true, false, true, false},
	{2725, 24027, "Bold Living Ruby", 3, false, true, false, false, false},
	{2726, 24028, "Delicate Living Ruby", 3, false, true, false, false, false},
	{2727, 24029, "Teardrop Living Ruby", 3, false, true, false, false, false},
	{2728, 24030, "Runed Living Ruby", 3, false, true, false, false, false},
	{2729, 24031, "Bright Living Ruby", 3, false, true, false, false, false},
	{2730, 24032, "Subtle Living Ruby", 3, false, true, false, false, false},
	{2731, 24033, "Solid Star of Elune", 3, false, false, false, true, false},
	{2732, 24035, "Sparkling Star of Elune", 3, false, false, false, true, false},
	{2733, 24037, "Lustrous Star of Elune", 3, false, false, false, true, false},
	{2734, 24047, "Brilliant Dawnstone", 3, false, false, true, false, false},
	{2735, 24048, "Smooth Dawnstone", 3, false, false, true, false, false},
	{2736, 24050, "Gleaming Dawnstone", 3, false, false, true, false, false},
	{2737, 24052, "Thick Dawnstone", 3, false, false, true, false, false},
	{2738, 24054, "Sovereign Nightseye", 3, false, true, false, true, false},
	{2739, 24055, "Shifting Nightseye", 3, false, true, false, true, false},
	{2740, 24056, "Glowing Nightseye", 3, false, true, false, true, false},
	{2741, 24057, "Royal Nightseye", 3, false, true, false, true, false},
	{2742, 24060, "Luminous Noble Topaz", 3, false, true, true, false, false},
	{2743, 24062, "Enduring Talasite", 3, false, false, true, true, false},
	{2744, 24065, "Dazzling Talasite", 3, false, false, true, true, false},
	{2752, 23098, "Inscribed Flame Spessarite", 2, false, true, true, false, false},
	{2753, 24058, "Inscribed Noble Topaz", 3, false, true, true, false, false},
	{2754, 24036, "Flashing Living Ruby", 3, false, true, false, false, false},
	{2755, 23100, "Glinting Flame Spessarite", 2, false, true, true, false, false},
	{2756, 24061, "Glinting Noble Topaz", 3, false, true, true, false, false},
	{2757, 23104, "Jagged Deep Peridot", 2, false, false, true, true, false},
	{2758, 24067, "Jagged Talasite", 3, false, false, true, true, false},
	{2759, 24053, "Mystic Dawnstone", 3, false, false, true, false, false},
	{2760, 23101, "Potent Flame Spessarite", 2, false, true, true, false, false},
	{2761, 24059, "Potent Noble Topaz", 3, false, true, true, false, false},
	{2762, 23103, "Radiant Deep Peridot", 2, false, false, true, true, false},
	{2763, 24066, "Radiant Talasite", 3, false, false, true, true, false},
	{2764, 24051, "Rigid Dawnstone", 3, false, false, true, false, false},
	{2765, 24039, "Stormy Star of Elune", 3, false, false, false, true, false},
	{2827, 25890, "Destructive Skyfire Diamond", 3, false, false, false, false, true},
	{2828, 25893, "Mystical Skyfire Diamond", 3, false, false, false, false, true},
	{2829, 25894, "Swift Skyfire Diamond", 3, false, false, false, false, true},
	{2830, 25895, "Enigmatic Skyfire Diamond", 3, false, false, false, false, true},
	{2831, 25896, "Powerful Earthstorm Diamond", 3, false, false, false, false, true},
	{2832, 25897, "Bracing Earthstorm Diamond", 3, false, false, false, false, true},
	{2833, 25898, "Tenacious Earthstorm Diamond", 3, false, false, false, false, true},
	{2834, 25899, "Brutal Earthstorm Diamond", 3, false, false, false, false, true},
	{2835, 25901, "Insightful Earthstorm Diamond", 3, false, false, false, false, true},
	{2891, 27679, "Sublime Mystic Dawnstone", 4, true, false, true, false, false},
	--{2894, 27774, "zzOLDMighty Blood Garnet", 3, true, true, false, false, false},
	{2896, 27777, "Stark Blood Garnet", 3, true, true, false, false, false},
	--{2911, 28117, "zzOLDBold Ornate Ruby", 4, true, true, false, false, false},
	{2912, 28118, "Runed Ornate Ruby", 4, true, true, false, false, false},
	{2913, 28119, "Smooth Ornate Dawnstone", 4, true, false, true, false, false},
	{2914, 28120, "Gleaming Ornate Dawnstone", 4, true, false, true, false, false},
	--{2915, 28122, "zzOLDEnscribed Ornate Topaz", 4, true, true, true, false, false},
	{2916, 28123, "Potent Ornate Topaz", 4, true, true, true, false, false},
	--{2917, 27864, "Brian's Bryanite of Extended Cost Copying", 2, false, false, false, false, false},
	{2921, 27809, "Barbed Deep Peridot", 3, true, false, true, true, false},
	--{2922, 27811, "zzOLDMighty Blood Garnet", 3, true, true, false, false, false},
	{2923, 27820, "Notched Deep Peridot", 3, true, false, true, true, false},
	{2924, 27812, "Stark Blood Garnet", 3, true, true, false, false, false},
	{2942, 28290, "Smooth Golden Draenite", 2, false, false, true, false, false},
	{2943, 28360, "Mighty Blood Garnet", 3, true, true, false, false, false},
	{2944, 28361, "Mighty Blood Garnet", 3, true, true, false, false, false},
	{2945, 28362, "Bold Ornate Ruby", 4, true, true, false, false, false},
	{2946, 28363, "Inscribed Ornate Topaz", 4, true, true, true, false, false},
	{2947, 22460, "Prismatic Sphere", 3, false, true, true, true, false},
	{2948, 22459, "Void Sphere", 4, false, true, true, true, false},
	--{2949, 28388, "TCHILTON TEST RUBY", 4, false, true, false, false, false},
	--{2950, 28389, "TCHILTON TEST DAWNSTONE", 4, false, false, true, false, false},
	{2956, 28458, "Bold Tourmaline", 1, false, true, false, false, false},
	{2957, 28459, "Delicate Tourmaline", 1, false, true, false, false, false},
	{2958, 28460, "Teardrop Tourmaline", 1, false, true, false, false, false},
	{2959, 28461, "Runed Tourmaline", 1, false, true, false, false, false},
	{2960, 28462, "Bright Tourmaline", 1, false, true, false, false, false},
	{2961, 28463, "Solid Zircon", 1, false, false, false, true, false},
	{2962, 28464, "Sparkling Zircon", 1, false, false, false, true, false},
	{2963, 28465, "Lustrous Zircon", 1, false, false, false, true, false},
	{2964, 28466, "Brilliant Amber", 1, false, false, true, false, false},
	{2965, 28467, "Smooth Amber", 1, false, false, true, false, false},
	{2966, 28468, "Rigid Amber", 1, false, false, true, false, false},
	{2967, 28469, "Gleaming Amber", 1, false, false, true, false, false},
	{2968, 28470, "Thick Amber", 1, false, false, true, false, false},
	{2969, 28556, "Swift Windfire Diamond", 3, true, false, false, false, true},
	{2970, 28557, "Swift Starfire Diamond", 3, true, false, false, false, true},
	{2971, 28595, "Bright Blood Garnet", 2, false, true, false, false, false},
	{3045, 30546, "Sovereign Tanzanite", 4, true, true, false, true, false},
	{3046, 30547, "Luminous Fire Opal", 4, true, true, true, false, false},
	{3047, 30548, "Polished Chrysoprase", 4, true, false, true, true, false},
	{3048, 30549, "Shifting Tanzanite", 4, true, true, false, true, false},
	{3049, 30550, "Sundered Chrysoprase", 4, true, false, true, true, false},
	{3050, 30551, "Infused Fire Opal", 4, true, true, true, false, false},
	{3051, 30552, "Blessed Tanzanite", 4, true, true, false, true, false},
	{3052, 30553, "Pristine Fire Opal", 4, true, true, true, false, false},
	{3053, 30554, "Stalwart Fire Opal", 4, true, true, true, false, false},
	{3054, 30555, "Glowing Tanzanite", 4, true, true, false, true, false},
	{3055, 30556, "Glinting Fire Opal", 4, true, true, true, false, false},
	{3056, 30558, "Glimmering Fire Opal", 4, true, true, true, false, false},
	{3057, 30559, "Etched Fire Opal", 4, true, true, true, false, false},
	{3058, 30560, "Rune Covered Chrysoprase", 4, true, false, true, true, false},
	{3060, 30563, "Regal Tanzanite", 4, true, true, false, true, false},
	{3061, 30564, "Shining Fire Opal", 4, true, true, true, false, false},
	{3062, 30565, "Assassin's Fire Opal", 4, true, true, true, false, false},
	{3063, 30566, "Defender's Tanzanite", 4, true, true, false, true, false},
	{3064, 30572, "Imperial Tanzanite", 4, true, true, false, true, false},
	{3065, 30571, "Don Rodrigo's Heart", 3, true, true, false, false, false},
	{3066, 30573, "Mysterious Fire Opal", 4, true, true, true, false, false},
	{3067, 30574, "Brutal Tanzanite", 4, true, true, false, true, false},
	{3068, 30575, "Nimble Fire Opal", 4, true, true, true, false, false},
	{3069, 30581, "Durable Fire Opal", 4, true, true, true, false, false},
	{3070, 30582, "Deadly Fire Opal", 4, true, true, true, false, false},
	{3071, 30583, "Timeless Chrysoprase", 4, true, false, true, true, false},
	{3072, 30584, "Enscribed Fire Opal", 4, true, true, true, false, false},
	{3073, 30585, "Glistening Fire Opal", 4, true, true, true, false, false},
	{3074, 30586, "Seer's Chrysoprase", 4, true, false, true, true, false},
	{3075, 30587, "Champion's Fire Opal", 4, true, true, true, false, false},
	{3076, 30588, "Potent Fire Opal", 4, true, true, true, false, false},
	{3077, 30589, "Dazzling Chrysoprase", 4, true, false, true, true, false},
	{3078, 30590, "Enduring Chrysoprase", 4, true, false, true, true, false},
	{3079, 30591, "Empowered Fire Opal", 4, true, true, true, false, false},
	{3080, 30592, "Steady Chrysoprase", 4, true, false, true, true, false},
	{3081, 30593, "Iridescent Fire Opal", 4, true, true, true, false, false},
	{3082, 30594, "Effulgent Chrysoprase", 4, true, false, true, true, false},
	{3083, 30600, "Fluorescent Tanzanite", 4, true, true, false, true, false},
	{3084, 30601, "Beaming Fire Opal", 4, true, true, true, false, false},
	{3085, 30602, "Jagged Chrysoprase", 4, true, false, true, true, false},
	{3086, 30603, "Royal Tanzanite", 4, true, true, false, true, false},
	{3087, 30604, "Resplendent Fire Opal", 4, true, true, true, false, false},
	{3088, 30605, "Vivid Chrysoprase", 4, true, false, true, true, false},
	{3089, 30606, "Lambent Chrysoprase", 4, true, false, true, true, false},
	{3090, 30607, "Splendid Fire Opal", 4, true, true, true, false, false},
	{3091, 30608, "Radiant Chrysoprase", 4, true, false, true, true, false},
	{3099, 31116, "Infused Amethyst", 4, false, true, false, true, false},
	{3100, 31117, "Soothing Amethyst", 4, false, true, false, true, false},
	{3101, 31118, "Pulsing Amethyst", 4, false, true, false, true, false},
	{3103, 30598, "Don Amancio's Heart", 3, true, true, false, false, false},
	{3104, 31860, "Great Golden Draenite", 2, false, false, true, false, false},
	{3105, 31861, "Great Dawnstone", 3, false, false, true, false, false},
	{3106, 31862, "Balanced Shadow Draenite", 2, false, true, false, true, false},
	{3107, 31863, "Balanced Nightseye", 3, false, true, false, true, false},
	{3108, 31864, "Infused Shadow Draenite", 2, false, true, false, true, false},
	{3109, 31865, "Infused Nightseye", 3, false, true, false, true, false},
	{3110, 31866, "Veiled Flame Spessarite", 2, false, true, true, false, false},
	{3111, 31867, "Veiled Noble Topaz", 3, false, true, true, false, false},
	{3112, 31868, "Wicked Noble Topaz", 3, false, true, true, false, false},
	{3113, 31869, "Wicked Flame Spessarite", 2, false, true, true, false, false},
	{3115, 32193, "Bold Crimson Spinel", 4, false, true, false, false, false},
	{3116, 32194, "Delicate Crimson Spinel", 4, false, true, false, false, false},
	{3117, 32195, "Teardrop Crimson Spinel", 4, false, true, false, false, false},
	{3118, 32196, "Runed Crimson Spinel", 4, false, true, false, false, false},
	{3119, 32197, "Bright Crimson Spinel", 4, false, true, false, false, false},
	{3120, 32198, "Subtle Crimson Spinel", 4, false, true, false, false, false},
	{3121, 32199, "Flashing Crimson Spinel", 4, false, true, false, false, false},
	{3122, 32200, "Solid Empyrean Sapphire", 4, false, false, false, true, false},
	{3123, 32201, "Sparkling Empyrean Sapphire", 4, false, false, false, true, false},
	{3124, 32202, "Lustrous Empyrean Sapphire", 4, false, false, false, true, false},
	{3125, 32203, "Stormy Empyrean Sapphire", 4, false, false, false, true, false},
	{3126, 32204, "Brilliant Lionseye", 4, false, false, true, false, false},
	{3127, 32205, "Smooth Lionseye", 4, false, false, true, false, false},
	{3128, 32206, "Rigid Lionseye", 4, false, false, true, false, false},
	{3129, 32207, "Gleaming Lionseye", 4, false, false, true, false, false},
	{3130, 32208, "Thick Lionseye", 4, false, false, true, false, false},
	{3131, 32209, "Mystic Lionseye", 4, false, false, true, false, false},
	{3132, 32210, "Great Lionseye", 4, false, false, true, false, false},
	{3133, 32211, "Sovereign Shadowsong Amethyst", 4, false, true, false, true, false},
	{3134, 32212, "Shifting Shadowsong Amethyst", 4, false, true, false, true, false},
	{3135, 32213, "Balanced Shadowsong Amethyst", 4, false, true, false, true, false},
	{3136, 32214, "Infused Shadowsong Amethyst", 4, false, true, false, true, false},
	{3137, 32215, "Glowing Shadowsong Amethyst", 4, false, true, false, true, false},
	{3138, 32216, "Royal Shadowsong Amethyst", 4, false, true, false, true, false},
	{3139, 32217, "Inscribed Pyrestone", 4, false, true, true, false, false},
	{3140, 32218, "Potent Pyrestone", 4, false, true, true, false, false},
	{3141, 32219, "Luminous Pyrestone", 4, false, true, true, false, false},
	{3142, 32220, "Glinting Pyrestone", 4, false, true, true, false, false},
	{3143, 32221, "Veiled Pyrestone", 4, false, true, true, false, false},
	{3144, 32222, "Wicked Pyrestone", 4, false, true, true, false, false},
	{3145, 32223, "Enduring Seaspray Emerald", 4, false, false, true, true, false},
	{3146, 32224, "Radiant Seaspray Emerald", 4, false, false, true, true, false},
	{3147, 32225, "Dazzling Seaspray Emerald", 4, false, false, true, true, false},
	{3148, 32226, "Jagged Seaspray Emerald", 4, false, false, true, true, false},
	{3154, 32409, "Relentless Earthstorm Diamond", 3, false, false, false, false, true},
	{3155, 32410, "Thundering Skyfire Diamond", 3, false, false, false, false, true},
	{3156, 32634, "Unstable Amethyst", 3, true, true, false, true, false},
	{3157, 32635, "Unstable Peridot", 3, true, false, true, true, false},
	{3158, 32636, "Unstable Sapphire", 3, true, true, false, true, false},
	{3159, 32637, "Unstable Citrine", 3, true, true, true, false, false},
	{3160, 32638, "Unstable Topaz", 3, true, true, true, false, false},
	{3161, 32639, "Unstable Talasite", 3, true, true, true, false, false},
	{3162, 32640, "Potent Unstable Diamond", 3, false, false, false, false, true},
	{3163, 32641, "Imbued Unstable Diamond", 3, false, false, false, false, true},
	--{3197, 32735, "Radiant Spencerite", 4, true, false, true, true, false},
	{3201, 32833, "Purified Jaggal Pearl", 2, false, true, false, true, false},
	{3202, 32836, "Purified Shadow Pearl", 3, false, true, false, true, false},
}

--[[ 
	1: EnchantId
	2: ItemId
	3: Name
	4: Quality
	5: Unique
	6: Red
	7: Yellow
	8: Blue
	9: Meta
--]]

function ItemValue:LoadJewels()
	local JewelByEnchantId = {}
	local JewelByName = {}
	
	for _, Jewel in pairs(Jewels) do
		JewelByEnchantId[Jewel[1]] = Jewel
		JewelByName[Jewel[3]] = Jewel
	end
	
	for i=#ItemValue.db.profile.Jewels,1,-1 do
		local Jewel = ItemValue.db.profile.Jewels[i]
		if JewelByName[Jewel[3]] then
			table.remove(ItemValue.db.profile.Jewels, i)
		else
			JewelByEnchantId[Jewel[1]] = Jewel
			JewelByName[Jewel[3]] = Jewel
		end
	end
	
	Jewels = nil
	
	return JewelByName, JewelByEnchantId
end

function ItemValue:LoadJewelFilters()
	local EnabledJewels = ItemValue.db.profile.EnabledJewels
	local Jewels = ItemValue.JewelByName
	
	local JewelFilters = {
		order	= 8,
		type	= "group",
		name	= L["Jewel Filters"],
		desc	= L["Which Jewels should be used."],
		args = {
			disable = {
				order = 1,
				type = "group",
				name = L["Disable"],
				desc = L["Disable Jewels"],
				args = {
					All = {
						order = 1,
						type = "execute",
						name = L["All"],
						desc = L["Disable All"],
						func = function()
							for JewelName in pairs(Jewels) do
								EnabledJewels[JewelName] = false
							end
						end,
					},
					Quality = {
						order = 2,
						type = "text",
						name = L["Quality"],
						desc = L["Disable Quality"],
						validate = {["1"] = "Common", ["2"] = "Uncommon", ["3"] = "Rare", ["4"] = "Epic"},
						get = false,
						set = function(v)
							for JewelName, Jewel in pairs(Jewels) do
								if Jewel[4] == tonumber(v) then EnabledJewels[JewelName] = false end
							end
						end,
					},
					Name = {
						order = 3,
						type = "text",
						name = L["Name"],
						desc = L["Disables a Jewel if it contains a certain string."],
						validate = function(v) return (v and string.len(v) ~= 0) end,
						usage = "<Part of Name>",
						get = false,
						set = function(v)
							for JewelName, Jewel in pairs(Jewels) do
								if string.find(string.lower(Jewel[3]), string.lower(v)) then EnabledJewels[JewelName] = false end
							end
						end,
					},
				},
			},
			Enable = {
				order = 2,
				type = "group",
				name = L["Enable"],
				desc = L["Enable Jewels"],
				args = {
					All = {
						order = 1,
						type = "execute",
						name = L["All"],
						desc = L["Enable All"],
						func = function()
							for JewelName in pairs(Jewels) do
								EnabledJewels[JewelName] = true
							end
						end,
					},
					Quality = {
						order = 2,
						type = "text",
						name = L["Quality"],
						desc = L["Enable Quality"],
						validate = {["1"] = "Common", ["2"] = "Uncommon", ["3"] = "Rare", ["4"] = "Epic"},
						get = false,
						set = function(v)
							for JewelName, Jewel in pairs(Jewels) do
								if Jewel[4] == tonumber(v) then EnabledJewels[JewelName] = true end
							end
						end,
					},
					Name = {
						order = 3,
						type = "text",
						name = L["Name"],
						desc = L["Enables a Jewel if it contains a certain string."],
						validate = function(v) return (v and string.len(v) ~= 0) end,
						usage = "<Part of Name>",
						get = false,
						set = function(v)
							for JewelName, Jewel in pairs(Jewels) do
								if string.find(string.lower(Jewel[3]), string.lower(v)) then EnabledJewels[JewelName] = true end
							end
						end,
					},
				},
			},
			Jewels = {
				order = 3,
				type = "group",
				name = L["Jewels"],
				desc = L["Jewels"],
				args = {},
			},
		},
	}
	
	for JewelName, Jewel in pairs(ItemValue.JewelByName) do
		JewelFilters.args.Jewels.args[JewelName] = {
			--order	= 1,
			type	= "toggle",
			name	= JewelName,
			desc	= JewelName,
			get		= function() return EnabledJewels[JewelName] end,
			set		= function(v) EnabledJewels[JewelName] = v ItemValue:ClearCache() end,
		}
	end
	
	return JewelFilters
end
